import json
import time

# (1.3) Load the data from weather.json as a dictionary. Use this dictionary to
# print the name of the city, and the timestamp, temperature, and description
# from the weather report.
pass # your code here

# (1.4) Write two helper functions that return human-readable versions of the
# timestamp and temperature from the weather report. Test these functions
# by calling them in your main() function and printing the results.
def convert_time(time_unix):
    """
    Get the date and time in human-readable form.
    HINT: use the time library.

    Parameters
    ----------
    time_unix (int): A UNIX timestamp.

    Returns
    -------
    dt (str): A nicely formatted datetime.
    """

    pass

def convert_temp(temp_kelvin):
    """
    Convert a temperature from Kelvin to Fahrenheit.

    Parameters
    ----------
    temp_kelvin (float): A temperature, in Kelvin.

    Returns
    -------
    temp_fahrenheit (float): A temperature, in degrees Fahrenheit.
    """

    pass



# Test it!!
# print(convert_time(1098934843))
# print(convert_temp(273.2))

# (1.5) Write a function that prints a summary of the weather report. Test this
# functions by calling it in your main() function.
def print_weather(weather_dictionary):
    print("YOUR_CODE_HERE")

# Test it!!
# print_weather(whatever_you_called_your_weather_dictionary)

# (2) Implement the WeatherReport class.
class WeatherReport:
    '''
    This class provides a concise representation of a weather forecast of the
    kind returned by querying the OpenWeatherMap API.
    '''

    # (2.1) Implement the class constructor, __init__.
    def __init__(self, weather):
        """
        Initialize an instance of a WeatherReport from a dictionary forecast. 
        The following attributes mirror their representation in the dictionary:
        * id
        * name
        * weather
        
        These are new, or involve transformations of the data:
        * time: this should be a formatted string, not a UNIX timestamp
        * temp: this should be in Fahrenheit
        * humidity: this should be extracted from the "main" dictionary 

        Parameters
        ----------
        self: The pointer to the class.
        weather (dict): A dictionary containing a weather forecast from OpenWeatherMap.

        Returns
        -------
        An instance of class WeatherReport.
        """
        self.id = None
        self.name = None
        self.time = None
        self.temp = None
        self.humidity = None
        self.weather = None
        pass

    # (2.2) Implement the get_description method.

    def get_description(self):
        """
        Return a string of comma-separated weather descriptions.

        HINT: use join().
        """
        pass

    # (2.3) Implement the summarize() method.
    def summarize(self):
        """
        Print a summary of the forecast contained in the WeatherReport.

        HINT: This should be basically the same as print_forecast.
        """
        pass
    
    # (2.4) Implement the  __str__ method.
    def __str__(self):
        """
        Override the string representation of the class with something more useful.

        HINT: This should be basically the same as summarize, except that it 
        returns a string instead of printing.
        """
        pass


# boston_weather = WeatherReport(weather_dict)
# print(boston_weather.name)
# print(boston_weather.time)
# print(boston_weather.temp)
# print(boston_weather.weather[0]["description"])
# print(boston_weather.get_description())
# boston_weather.summarize()
# print(boston_weather)

# Extra stuff!
import requests


# this API key is here as a backup in case there are technical issues -
# please try to get your own API key before using this one.
BACKUP_API_KEY = "47d87def8aaa79181f84f7419c34b605"
